function $AdfRowKeySetChangeEvent$$($source$$102$$, $eventType$$15$$, $removedSet$$2$$, $addedSet$$2$$) {
  arguments.length && this.Init($source$$102$$, $eventType$$15$$, $removedSet$$2$$, $addedSet$$2$$);
}
$goog$exportSymbol$$("AdfRowKeySetChangeEvent", $AdfRowKeySetChangeEvent$$);
$AdfObject$$.$createSubclass$($AdfRowKeySetChangeEvent$$, $AdfComponentEvent$$);
$AdfRowKeySetChangeEvent$$.$createRowKeySetChangeEvent$ = function $$AdfRowKeySetChangeEvent$$$$createRowKeySetChangeEvent$$($source$$103$$, $eventType$$16$$, $eventObject_removedSet$$3$$, $addedSet$$3$$) {
  var $added$$ = null, $removed$$ = null;
  if ($eventObject_removedSet$$3$$) {
    if ($addedSet$$3$$) {
      for (var $key$$35$$ in $eventObject_removedSet$$3$$) {
        $addedSet$$3$$[$key$$35$$] || ($removed$$ || ($removed$$ = {}), $removed$$[$key$$35$$] = !0);
      }
    } else {
      $removed$$ = {}, $AdfCollections$$.$copyInto$($removed$$, $eventObject_removedSet$$3$$);
    }
  }
  if ($addedSet$$3$$) {
    if ($eventObject_removedSet$$3$$) {
      for ($key$$35$$ in $addedSet$$3$$) {
        $eventObject_removedSet$$3$$[$key$$35$$] || ($added$$ || ($added$$ = {}), $added$$[$key$$35$$] = !0);
      }
    } else {
      $added$$ = {}, $AdfCollections$$.$copyInto$($added$$, $addedSet$$3$$);
    }
  }
  if ($added$$ || $removed$$) {
    $eventObject_removedSet$$3$$ = null;
    switch($eventType$$16$$) {
      case $AdfRowDisclosureEvent$$.$ROW_DISCLOSURE_EVENT_TYPE$:
        $eventObject_removedSet$$3$$ = new $AdfRowDisclosureEvent$$($source$$103$$, $removed$$, $added$$);
        break;
      case $AdfSelectionEvent$$.$SELECTION_EVENT_TYPE$:
        $eventObject_removedSet$$3$$ = new $AdfSelectionEvent$$($source$$103$$, $removed$$, $added$$);
    }
    return $eventObject_removedSet$$3$$;
  }
  return null;
};
$goog$exportSymbol$$("AdfRowKeySetChangeEvent.createRowKeySetChangeEvent", $AdfRowKeySetChangeEvent$$.$createRowKeySetChangeEvent$);
$AdfRowKeySetChangeEvent$$.$createOrderedRowKeySetChangeEvent$ = function $$AdfRowKeySetChangeEvent$$$$createOrderedRowKeySetChangeEvent$$($source$$104$$, $eventType$$17$$, $eventObject$$1_removedSet$$4$$, $addedSet$$4$$) {
  var $added$$1$$ = null, $removed$$1$$ = null;
  $eventObject$$1_removedSet$$4$$ && !$eventObject$$1_removedSet$$4$$.length && ($eventObject$$1_removedSet$$4$$ = null);
  $addedSet$$4$$ && !$addedSet$$4$$.length && ($addedSet$$4$$ = null);
  if ($eventObject$$1_removedSet$$4$$) {
    if ($AdfAssert$$.$assertArray$($eventObject$$1_removedSet$$4$$), $addedSet$$4$$) {
      for (var $keyCount$$1$$ = $eventObject$$1_removedSet$$4$$.length, $i$$49$$ = 0;$i$$49$$ < $keyCount$$1$$;$i$$49$$++) {
        var $currAddedKey_currRemovedKey$$ = $eventObject$$1_removedSet$$4$$[$i$$49$$];
        $addedSet$$4$$[$currAddedKey_currRemovedKey$$] || ($removed$$1$$ || ($removed$$1$$ = []), $removed$$1$$[$currAddedKey_currRemovedKey$$] = $removed$$1$$.length, $removed$$1$$.push($currAddedKey_currRemovedKey$$));
      }
    } else {
      $removed$$1$$ = $AdfCollections$$.$cloneArray$($eventObject$$1_removedSet$$4$$);
    }
  }
  if ($addedSet$$4$$) {
    if ($AdfAssert$$.$assertArray$($addedSet$$4$$), $eventObject$$1_removedSet$$4$$) {
      for ($keyCount$$1$$ = $addedSet$$4$$.length, $i$$49$$ = 0;$i$$49$$ < $keyCount$$1$$;$i$$49$$++) {
        $currAddedKey_currRemovedKey$$ = $addedSet$$4$$[$i$$49$$], $eventObject$$1_removedSet$$4$$[$currAddedKey_currRemovedKey$$] || ($added$$1$$ || ($added$$1$$ = []), $added$$1$$[$currAddedKey_currRemovedKey$$] = $added$$1$$.length, $added$$1$$.push($currAddedKey_currRemovedKey$$));
      }
    } else {
      $added$$1$$ = $AdfCollections$$.$cloneArray$($addedSet$$4$$);
    }
  }
  if ($added$$1$$ || $removed$$1$$) {
    $eventObject$$1_removedSet$$4$$ = null;
    switch($eventType$$17$$) {
      case $AdfRowDisclosureEvent$$.$ROW_DISCLOSURE_EVENT_TYPE$:
        $eventObject$$1_removedSet$$4$$ = new $AdfRowDisclosureEvent$$($source$$104$$, $removed$$1$$, $added$$1$$);
        break;
      case $AdfSelectionEvent$$.$SELECTION_EVENT_TYPE$:
        $eventObject$$1_removedSet$$4$$ = new $AdfSelectionEvent$$($source$$104$$, $removed$$1$$, $added$$1$$);
    }
    return $eventObject$$1_removedSet$$4$$;
  }
  return null;
};
$goog$exportSymbol$$("AdfRowKeySetChangeEvent.createOrderedRowKeySetChangeEvent", $AdfRowKeySetChangeEvent$$.$createOrderedRowKeySetChangeEvent$);
$AdfRowKeySetChangeEvent$$.prototype.$getRemovedSet$ = function $$AdfRowKeySetChangeEvent$$$$$getRemovedSet$$() {
  return this.$_removedSet$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfRowKeySetChangeEvent.prototype.getRemovedSet", {$getRemovedSet$:$AdfRowKeySetChangeEvent$$.prototype.$getRemovedSet$});
$AdfRowKeySetChangeEvent$$.prototype.$getAddedSet$ = function $$AdfRowKeySetChangeEvent$$$$$getAddedSet$$() {
  return this.$_addedSet$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfRowKeySetChangeEvent.prototype.getAddedSet", {$getAddedSet$:$AdfRowKeySetChangeEvent$$.prototype.$getAddedSet$});
$AdfRowKeySetChangeEvent$$.prototype.$toDebugString$ = function $$AdfRowKeySetChangeEvent$$$$$toDebugString$$() {
  var $superString$$6$$ = $AdfRowKeySetChangeEvent$$.$superclass$.$toDebugString$.call(this);
  return $superString$$6$$.substring(0, $superString$$6$$.length - 1) + ", removed\x3d" + this.$_removedSet$ + ", added\x3d" + this.$_addedSet$ + "]";
};
$AdfObject$$.$exportPrototypeSymbol$("AdfRowKeySetChangeEvent.prototype.toDebugString", {$toDebugString$:$AdfRowKeySetChangeEvent$$.prototype.$toDebugString$});
$AdfRowKeySetChangeEvent$$.prototype.Init = function $$AdfRowKeySetChangeEvent$$$$Init$($source$$105$$, $type$$114$$, $removedSet$$5$$, $addedSet$$5$$) {
  $AdfRowKeySetChangeEvent$$.$superclass$.Init.call(this, $source$$105$$, $type$$114$$);
  this.$_removedSet$ = $removedSet$$5$$;
  this.$_addedSet$ = $addedSet$$5$$;
  this.$setPartial$(!0);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfRowKeySetChangeEvent.prototype.Init", {Init:$AdfRowKeySetChangeEvent$$.prototype.Init});
$AdfRowKeySetChangeEvent$$.prototype.$propagatesToServer$ = function $$AdfRowKeySetChangeEvent$$$$$propagatesToServer$$() {
  return !0;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfRowKeySetChangeEvent.prototype.propagatesToServer", {$propagatesToServer$:$AdfRowKeySetChangeEvent$$.prototype.$propagatesToServer$});
